package com.izenpe.zain.cliente.smime;

import org.apache.axis.encoding.Base64;

import com.izenpe.zain.client.ZainConfig;
import com.izenpe.zain.cliente.util.Constantes;
import com.izenpe.zain.cliente.util.Propiedades;
import com.izenpe.zain.cliente.util.ZainUtil;
import com.safelayer.trustedx.client.smartwrapper.Constants;
import com.safelayer.trustedx.client.smartwrapper.SmartSignRequest;
import com.safelayer.trustedx.client.smartwrapper.SmartSignResponse;

public class GeneracionFirmaSMIME {
	// Nombre del fichero a utilizar para la Generación de la firma SMIME.
	private static final String fileName = "mime.txt";

	public static void main(String[] args) {
		try {
			// Asignación de la configuración de forma programática
			ZainConfig.setCurrent(Propiedades.ZAIN_CONFIG);

			/*
			 * Se crea la petición a través de la URL:
			 * https://212.142.249.27:8443/trustedx-gw/SoapGateway
			 */
			SmartSignRequest smartSignReq = new SmartSignRequest(Propiedades.ZAIN_ENDPOINT);

			// Se establece el perfil de firma SMIME en la petición de
			// Generación de firma.
			smartSignReq.setProfile(Constants.Profile.SMIME);
			
			//Especificamos el formato AdES-BES
			smartSignReq.setSignatureFormat(Constants.SignatureFormat.BES);
			
			/*
			 * Se establece el idioma de la petición en español. 2
			 * posibilidades: 1. Español: 'es' 2. Inglés: 'en'
			 */
			smartSignReq.setLanguage("es");

			// Certificado con el que realizar la firma.
			smartSignReq.setKeySubjectName(Propiedades.ZAIN_SIGNER);

			/*
			 * Algoritmo de hash a utilizar para la firma. En caso de omitir
			 * esta línea de código, la firma por defecto es 'sha1'.
			 * Posibilidades: 1. md5 2. sha1 3. sha256 4. sha384 5. sha512
			 */
			smartSignReq.setDigestAlgorithm("sha1");

			// Datos a firmar.
			smartSignReq.setInputMime(Base64.encode(ZainUtil.readBinaryFile("data/input/" + fileName)));

			// Envío de la petición.
			SmartSignResponse smartSignResp = smartSignReq.send();

			/*
			 * Se comprueba la validez de la respuesta y se escribe la respuesta
			 * de Generación de firma SMIME en un fichero en disco.
			 */
			if (Constantes.RMAJOR_SUCCESS.equals((smartSignResp.getResultMajor()))
					&& smartSignResp.getResultMinor() == null) {
				String mime = smartSignResp.getSignatureMime();
				byte[] data = Base64.decode(mime);
				String destFilename = "data/output/" + "smime-v2.txt";
				ZainUtil.writeBinaryFile(destFilename, data);
				System.out.println("La firma ha sido generada con éxito");
			} else {
				System.out.println("Error en la Generación de Firma:" + smartSignResp.getResultMessage());
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
}